
; fast flash download, PJRC MP3 player

; initial test version for 8051 development board



.equ	auxr1, 0xA2
.equ	write_error_flag, 2
.equ	abort_error_flag, 3
.equ	any_error_flag, 4

.equ	reg2, 2
.equ	flash_a16_pin, 0x90

.equ	cout, 0x0030
.equ	cin, 0x0032
.equ	pstr, 0x0038
.equ	newline, 0x0048


	.org	0x2000


	mov	sp, #0x30
	mov	dptr, #msg_begin
	lcall	pstr
	mov	ie, #0
	mov	psw, #0
	mov	r3, #0
	mov	r4, #0
	clr	write_error_flag
	clr	abort_error_flag
	clr	any_error_flag
	inc	auxr1
	mov	dptr, #0x8000
	inc	auxr1


main_loop:
	jnb	ri, *
	clr	ri
	mov	a, sbuf
	mov	r2, a
	mov	dptr, #command_bytes_table
	movc	a, @a+dptr
	jnz	cmd_zero

write_flash:
	mov	dptr, #0xDA4E
	mov	a, #0xE2
	movx	@dptr, a
	mov	dptr, #0xA5B1
	mov	a, #0x1D
	movx	@dptr, a
	mov	dptr, #0xDA4E
	mov	a, #0x60
	movx	@dptr, a
	inc	auxr1
	mov	a, r2
	movx	@dptr, a
	add	a, r3
	mov	r3, a
	clr	a
	addc	a, r4
	mov	r4, a
	nop	
	nop	
	nop	
	nop	
	nop	
	nop	
	clr	a
	movc	a, @a+dptr
	cjne	a, reg2, write_error
	inc	dptr
	inc	auxr1
	sjmp	main_loop
write_error:
	setb	write_error_flag
	inc	dptr
	inc	auxr1
	sjmp	main_loop



cmd_zero:
	cjne	a, #code_zero, cmd_three_ff
	mov	r2, #0
	sjmp	write_flash


cmd_three_ff:
	cjne	a, #code_three_ff, cmd_two_ff
	inc	auxr1
	clr	a
	movc	a, @a+dptr
	inc	dptr
	cpl	a
	jz	cmd_ff_1
	setb	write_error_flag
cmd_ff_1:
	clr	a
	movc	a, @a+dptr
	inc	dptr
	cpl	a
	jz	cmd_ff_2
	setb	write_error_flag
cmd_ff_2:
	clr	a
	movc	a, @a+dptr
	inc	dptr
	cpl	a
	jz	cmd_ff_3
	setb	write_error_flag
cmd_ff_3:
	inc	auxr1
	sjmp	main_loop


cmd_two_ff:
	cjne	a, #code_two_ff, cmd_escape_byte
	inc	auxr1
	sjmp	cmd_ff_1


cmd_escape_byte:
	cjne	a, #code_escape_byte, cmd_address
	jnb	ri, *
	clr	ri
	mov	a, sbuf
	jnb	acc.7, dl_abort_h
	clr	acc.7
	mov	r2, a
	sjmp	write_flash


dl_abort_h:
	ljmp	dl_abort


cmd_address:
	cjne	a, #code_address, cmd_115200_baud
	jnb	ri, *
	clr	ri
	mov	a, sbuf
	jnb	acc.7, dl_abort_h
	inc	auxr1
	mov	dpl, a
	inc	auxr1
	jnb	ri, *
	clr	ri
	mov	a, sbuf
	jnb	acc.7, dl_abort_h
	inc	auxr1
	mov	dph, a
	inc	auxr1
	jnb	ri, *
	clr	ri
	mov	b, sbuf
	jnb	b.7, dl_abort_h
	inc	auxr1
	mov	C, b.0
	mov	a, dpl
	mov	acc.7, C
	mov	dpl, a
	mov	C, b.1
	mov	a, dph
	mov	acc.7, C
	mov	dph, a
	inc	auxr1
	mov	C, b.2
	mov	flash_a16_pin, C
	ljmp	main_loop


cmd_115200_baud:
	cjne	a, #code_115200_baud, cmd_checksum
	sjmp	dl_abort


cmd_checksum:
	cjne	a, #code_checksum, cmd_end_of_data
	sjmp	dl_abort


cmd_end_of_data:
	cjne	a, #code_end_of_data, cmd_undef_skip
	sjmp	wait_silent


cmd_undef_skip:
	cjne	a, #code_undef_skip, dl_abort
	jnb	ri, *
	clr	ri
	mov	a, sbuf
	jnb	acc.7, dl_abort
	anl	a, #0x7F
	inc	auxr1
	add	a, dpl
	mov	dpl, a
	mov	a, dph
	addc	a, #0
	mov	dph, a
	inc	auxr1
	ljmp	main_loop



dl_abort:
	setb	abort_error_flag
	sjmp	wait_silent


wait_silent_reset:
	clr	ri
	mov	a, sbuf

wait_silent:
	mov	r2, #0
wait_silent_loop:
	jb	ri, wait_silent_reset
	mov	r3, #45
	nop	
	djnz	r3, *
	djnz	r2, wait_silent_loop



print_write_error:
	jnb	write_error_flag, print_abort_error
	setb	any_error_flag
	mov	dptr, #msg_write_error
	lcall	pstr

print_abort_error:
	jnb	abort_error_flag, print_no_error
	setb	any_error_flag
	mov	dptr, #msg_abort_error
	lcall	pstr

print_no_error:
	jb	any_error_flag, finished
	mov	dptr, #msg_no_error
	lcall	pstr

finished:
	ljmp	0



msg_write_error:
	.db	"ERROR: some data could not be written to flash rom",13,10,0
msg_abort_error:
	.db	"ERROR: transfer aborted "
	.db	"(some data may not be written)",13,10,0
msg_no_error:
	.db	"OK: Fast Flash Download completed, "
	.db	"No Errors Detected :)",13,10,0



.equ	code_zero, 1		; 0x5A
.equ	code_two_ff, 2		; 0x2D
.equ	code_three_ff, 3	; 0x19
.equ	code_escape_byte, 4	; 0x59
.equ	code_address, 5		; 0x29
.equ	code_115200_baud, 6	; 0x6A
.equ	code_checksum, 7	; 0x3C
.equ	code_end_of_data, 8	; 0x58
.equ	code_undef_skip, 9	; 0x1D
.equ	code_abort, 10		; 0x1B and 0x00


command_bytes_table:
	.db	code_abort,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0
	.db	0,0,0,0, 0,0,0,0
	.db	    0,code_three_ff,0,code_abort,0,code_undef_skip,0,0
	.db	0,0,0,0, 0,0,0,0, 0,code_address,0,0,0,code_two_ff,0,0
	.db	0,0,0,0, 0,0,0,0, 0,0,0,0,code_checksum,0,0,0
	.db	0,0,0,0, 0,0,0,0, 0,0,0,0,0,0,0,0
	.db	0,0,0,0, 0,0,0,0
	.db	    code_end_of_data,code_escape_byte,code_zero,0,0,0,0,0
	.db	0,0,0,0, 0,0,0,0, 0,0,code_115200_baud,0, 0,0,0,0
	.db	0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0

	.db	0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0
	.db	0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0
	.db	0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0
	.db	0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0
	.db	0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0
	.db	0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0
	.db	0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0
	.db	0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0


msg_begin:
	.db	15,"Begin Fast Flash Download",13,10,0
msg_addr:
	.db	"Addr=",0





